library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;


entity uhr is
    Port ( MEINECLOCK : in  STD_LOGIC;
           LEDROT : out  STD_LOGIC;
           LEDGRUEN : out  STD_LOGIC;
           DIGIT12P34 : out  STD_LOGIC_VECTOR (4 downto 0);
           ABCDEFG : out  STD_LOGIC_VECTOR (6 downto 0);
           GROUND123 : out  STD_LOGIC_VECTOR (2 downto 0);
           TASTE123 : in  STD_LOGIC_VECTOR (2 downto 0));
end uhr;

architecture Behavioral of uhr is

--                                     ABCDEFG
constant ZIFFER0: STD_LOGIC_VECTOR := "1111110";
constant ZIFFER1: STD_LOGIC_VECTOR := "0110000";
constant ZIFFER2: STD_LOGIC_VECTOR := "1101101";
constant ZIFFER3: STD_LOGIC_VECTOR := "1111001";
constant ZIFFER4: STD_LOGIC_VECTOR := "0110011";
constant ZIFFER5: STD_LOGIC_VECTOR := "1011011";
constant ZIFFER6: STD_LOGIC_VECTOR := "1011111";
constant ZIFFER7: STD_LOGIC_VECTOR := "1110000";
constant ZIFFER8: STD_LOGIC_VECTOR := "1111111";
constant ZIFFER9: STD_LOGIC_VECTOR := "1111011";


    signal zaehler    : integer range 0 to 2999999 := 0;
    signal D1     : integer range 0 to 9 := 0; -- Stunden obere Stelle
    signal D2     : integer range 0 to 9 := 0; -- Stunden untere Stelle
    signal D3     : integer range 0 to 9 := 0; -- Minuten obere Stelle
    signal D4     : integer range 0 to 9 := 0; -- Minuten untere Stelle
    signal D1_anzeige : std_logic_vector (6 downto 0) := "0000000";
    signal D2_anzeige : std_logic_vector (6 downto 0) := "0000000";
    signal D3_anzeige : std_logic_vector (6 downto 0) := "0000000";
    signal D4_anzeige : std_logic_vector (6 downto 0) := "0000000";
	 	 
    signal logikpegel : std_logic := '0';
    signal auswahl    : std_logic_vector (4 downto 0) := "01111";
    signal tasten    : std_logic_vector (2 downto 0) := "111";
	 
	 signal blockiert : std_logic := '0';
	 
    begin
       process begin
            wait until rising_edge(MEINECLOCK);
				
				
            if (zaehler<2999999) then
                zaehler <= zaehler+1;
            else -- schalten im Halb-Sekundentakt
                blockiert <= '0';				
                zaehler <= 0;
                logikpegel <= not logikpegel;
					 if(D4<9) then 
					     D4 <= D4+1;  -- Minuten untere Stelle
					 else
					     D4 <= 0;
						  if(D3<5) then
      				      D3 <= D3+1; -- Minuten obere Stelle
						  else
      				      D3 <= 0; 
								if( ((D2<9) and (D1<2)) or ((D2<3) and (D1=2)) ) then -- Stunden untere Stelle
								    D2 <= D2+1;
							   else
                            D2 <= 0;
									 if(D1<2) then -- Stunden obere Stelle
									    D1 <= D1+1;
									 else
                               D1 <= 0;
                            end if;										 
                        end if;									 
                    end if;						  
					 end if;
            end if;
				
				if ( (TASTE123(0) = '0') and (blockiert='0')) then 
				            blockiert <= '1';
								if( ((D2<9) and (D1<2)) or ((D2<3) and (D1=2)) ) then -- Stunden untere Stelle
								    D2 <= D2+1;
							   else
                            D2 <= 0;
									 if(D1<2) then -- Stunden obere Stelle
									    D1 <= D1+1;
									 else
                               D1 <= 0;
                            end if;										 
                        end if;									 
				elsif ( (TASTE123(1) = '0') and (blockiert='0') ) then 
				    blockiert <= '1';
					 if(D4<9) then 
					     D4 <= D4+1;  -- Minuten untere Stelle
					 else
					     D4 <= 0;
						  if(D3<5) then
      				      D3 <= D3+1; -- Minuten obere Stelle
						  else
      				      D3 <= 0; 
						  end if;
					end if;	  
				elsif ( (TASTE123(2) = '0') and (blockiert='0') ) then 
				    blockiert <= '1';				
					 if(D4>1) then 
					     D4 <= D4-2;  -- Minuten untere Stelle
					 else
					     D4 <= 9;
						  if(D3>0) then
      				      D3 <= D3-1; -- Minuten obere Stelle
						  else
      				      D3 <= 5; 
						  end if;
					end if;	  
			   end if;								

-- Umwandlung Ziffer in Digit:				
				case D1 is
				    when 0 => 
					     D1_anzeige <= ZIFFER0;  
				    when 1 => 
					     D1_anzeige <= ZIFFER1;  
				    when 2 => 
					     D1_anzeige <= ZIFFER2;  
				    when 3 => 
					     D1_anzeige <= ZIFFER3;  
				    when 4 => 
					     D1_anzeige <= ZIFFER4;  
				    when 5 => 
					     D1_anzeige <= ZIFFER5;  
				    when 6 => 
					     D1_anzeige <= ZIFFER6;  
				    when 7 => 
					     D1_anzeige <= ZIFFER7;  
				    when 8 => 
					     D1_anzeige <= ZIFFER8;  
				    when 9 => 
					     D1_anzeige <= ZIFFER9;  
				end case;
				
				case D2 is
				    when 0 => 
					     D2_anzeige <= ZIFFER0;  
				    when 1 => 
					     D2_anzeige <= ZIFFER1;  
				    when 2 => 
					     D2_anzeige <= ZIFFER2;  
				    when 3 => 
					     D2_anzeige <= ZIFFER3;  
				    when 4 => 
					     D2_anzeige <= ZIFFER4;  
				    when 5 => 
					     D2_anzeige <= ZIFFER5;  
				    when 6 => 
					     D2_anzeige <= ZIFFER6;  
				    when 7 => 
					     D2_anzeige <= ZIFFER7;  
				    when 8 => 
					     D2_anzeige <= ZIFFER8;  
				    when 9 => 
					     D2_anzeige <= ZIFFER9;  
				end case;

				case D3 is
				    when 0 => 
					     D3_anzeige <= ZIFFER0;  
				    when 1 => 
					     D3_anzeige <= ZIFFER1;  
				    when 2 => 
					     D3_anzeige <= ZIFFER2;  
				    when 3 => 
					     D3_anzeige <= ZIFFER3;  
				    when 4 => 
					     D3_anzeige <= ZIFFER4;  
				    when 5 => 
					     D3_anzeige <= ZIFFER5;  
				    when 6 => 
					     D3_anzeige <= ZIFFER6;  
				    when 7 => 
					     D3_anzeige <= ZIFFER7;  
				    when 8 => 
					     D3_anzeige <= ZIFFER8;  
				    when 9 => 
					     D3_anzeige <= ZIFFER9;  
				end case;

				case D4 is
				    when 0 => 
					     D4_anzeige <= ZIFFER0;  
				    when 1 => 
					     D4_anzeige <= ZIFFER1;  
				    when 2 => 
					     D4_anzeige <= ZIFFER2;  
				    when 3 => 
					     D4_anzeige <= ZIFFER3;  
				    when 4 => 
					     D4_anzeige <= ZIFFER4;  
				    when 5 => 
					     D4_anzeige <= ZIFFER5;  
				    when 6 => 
					     D4_anzeige <= ZIFFER6;  
				    when 7 => 
					     D4_anzeige <= ZIFFER7;  
				    when 8 => 
					     D4_anzeige <= ZIFFER8;  
				    when 9 => 
					     D4_anzeige <= ZIFFER9;  
				end case;

            -- Digit waehlen und richtig setzen, das aufgefrischt werden soll:
            case (zaehler mod 4) is
				    when 0 =>
                    DIGIT12P34 <= "01111";
                    ABCDEFG    <= D1_anzeige;						  
				    when 1 =>
                    DIGIT12P34 <= "10111";
                    ABCDEFG    <= D2_anzeige;						  
				    when 2 =>
                    DIGIT12P34 <= "11101";
                    ABCDEFG    <= D3_anzeige;						  
				    when others =>
                    DIGIT12P34 <= "11110";
                    ABCDEFG    <= D4_anzeige;						  
				end case;
        end process;      
    --- LEDROT und GRUEN blinken lassen
    LEDROT <= logikpegel;
    LEDGRUEN <= not logikpegel;
    --- GROUND123 auf Masse setzen:
    GROUND123 <= "000";
end Behavioral;

